#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
FILE *inputFile, *outputFile;
unsigned long int fileLength;
unsigned long int looper;
int looper2;
int len,i;
int outbytes;
char inbytes[16384];
int BlockReport;
int num;


errno=0;

if(argc != 3 && argc !=4)
{
printf("The Stripper v1.1\n");
printf("11/19/1998\n");
printf("Created by Justin Heiner\n\n");
printf("Description:\n");
printf("Strips all non-text characters from a file into another
file.\n\n");
printf("Usage:\nstripper SOURCE DESTINATION [BLOCKSIZE]\n\n");
printf("SOURCE: The file that you want to extract text from.\n");
printf("DESTINATION: The file that you want to output text to.\n");
printf("[BLOCKSIZE]: How much data should be processed at once.\n");
printf("             DEFAULT: 4096 bytes (4k) -- OPTIONAL\n");
printf("             ACCEPTABLE BLOCK SIZES: 1024, 2028, 4096,\n");
printf("                                     8192, 16384\n\n");
printf("Notes:\n");
printf("The maximum filesize that can be processed is about 4GB\n");
return 1;
}


if(argc == 3)
{
BlockReport=4096;
printf("Block Size: %i bytes\n",BlockReport);
}

if(argc == 4)
{
   num=atoi(argv[3]);

switch(num)
{
case 1024:
   BlockReport=1024;
   break;
case 2048:
   BlockReport=2048;
   break;
case 4096:
   BlockReport=4096;
   break;
case 8192:
   BlockReport=8192;
   break;
case 16384:
   BlockReport=16384;
   break;
default:  
   printf("%s is not a valid Block Size\n",argv[3]);
   printf("Using default block size, 4096\n");
   BlockReport=4096;
}

printf("Block Size: %i bytes\n",BlockReport);

}

inputFile = fopen(argv[1],"rb");
if(errno!=0)
{
   printf("Unable to open %s for reading\n",argv[1]);
   return(1);
}
outputFile = fopen(argv[2],"w+");
if(errno!=0)
{
   printf("Unable to open %s for writing\n",argv[2]);
   return(1);
}
fseek(inputFile, 0, SEEK_END);
fileLength = ftell(inputFile);
rewind(inputFile);

printf("Input file size: %li Kb\n",(fileLength/1024));

printf("\r0 Kb of %li",(fileLength/1024));
looper=0;

while((len=fread(inbytes,1,BlockReport,inputFile)) != 0)
{ 

   for(i=0;i<len;i++)
   {
      if((inbytes[i] >= 32) && (inbytes[i] <= 126))
         fwrite(&inbytes[i],1,1,outputFile);
      else if((inbytes[i] == 10) || (inbytes[i] == 13))
         fwrite(&inbytes[i],1,1,outputFile); 
   }
   
   looper+=BlockReport;
   printf("\r%lu Kb of %li Kb",(looper/1024),(fileLength/1024));
}

fileLength = ftell(outputFile);
printf("\rDone stripping text from %s\n",argv[1]);  
printf("Output file name: %s\n",argv[2]);
printf("Output file size: %li Kb\n",(fileLength/1024));
fclose(inputFile);
fclose(outputFile);
return(0);
}
